{% if enable_ssl %}
<VirtualHost *:80>
    ServerAdmin {{ server_admin }}
    ServerName {{ inventory_hostname }}
    {% for cname in host_cnames|default([]) %}
    ServerAlias {{ cname }}
    {% endfor %}

    RewriteEngine On
    RewriteRule ^.*$ https://%{SERVER_NAME}%{REQUEST_URI} [L,R=permanent]

    ErrorLog ${APACHE_LOG_DIR}/error.log
    CustomLog ${APACHE_LOG_DIR}/access.log combined

    LogLevel warn
    ServerSignature Off
</VirtualHost>

SSLStaplingCache shmcb:/tmp/stapling_cache(128000)

<VirtualHost *:443>
    ServerAdmin {{ server_admin }}
    ServerName {{ inventory_hostname }}
    {% for cname in host_cnames|default([]) %}
    ServerAlias {{ cname }}
    {% endfor %}

    SSLEngine on
    {% if enable_ssl == "certbot" %}
    SSLCertificateKeyFile /etc/letsencrypt/live/{{ inventory_hostname }}/privkey.pem
    SSLCertificateFile /etc/letsencrypt/live/{{ inventory_hostname }}/fullchain.pem
    {% else %}
    SSLCertificateKeyFile /etc/ssl/private/{{ inventory_hostname }}.key
    SSLCertificateFile /etc/ssl/certs/{{ inventory_hostname }}.pem
    {% endif %}

    SSLProtocol All -SSLv2 -SSLv3 -TLSv1 -TLSv1.1
    SSLCipherSuite ECDHE-RSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA
    SSLHonorCipherOrder on
    SSLCompression off
    SSLUseStapling on
    SSLStaplingStandardCacheTimeout 864000
    SSLStaplingErrorCacheTimeout 60
    SSLStaplingReturnResponderErrors off
    SSLStaplingFakeTryLater off

    Header add Strict-Transport-Security "max-age=15768000"

    ErrorLog ${APACHE_LOG_DIR}/{{ inventory_hostname }}_error.log
    CustomLog ${APACHE_LOG_DIR}/{{ inventory_hostname }}.log combined

    LogLevel warn
    ServerSignature Off

    SetEnv SITE_CONFIG "{{ ooh_dir }}/site_config.py"

    WSGIProcessGroup {{ inventory_hostname }}
    WSGIApplicationGroup %{GLOBAL}
    WSGIDaemonProcess {{ inventory_hostname }} user=www-data group=www-data \
        processes=2 threads=4 python-home={{ ooh_venv_dir }} \
        home={{ ooh_dir }} locale=en_GB.UTF-8 queue-timeout=15 \
        socket-timeout=15 connect-timeout=15 request-timeout=15 \
        deadlock-timeout=15 graceful-timeout=5
    WSGIScriptAlias / {{ ooh_venv_dir }}/bin/ooh.wsgi

    AllowEncodedSlashes NoDecode

    AAHeaderKey none
    AAHeaders all
    AACacheControl off

    <Location />
        AuthType Ucam-WebAuth
        <RequireAny>
            Require valid-user
            Require ip {{ kiosk_ips }}
        </RequireAny>
    </Location>
</VirtualHost>
{% else %}
<VirtualHost *:80>
    ServerAdmin {{ server_admin }}
    ServerName {{ inventory_hostname }}
    {% for cname in host_cnames|default([]) %}
    ServerAlias {{ cname }}
    {% endfor %}

    ErrorLog ${APACHE_LOG_DIR}/{{ inventory_hostname }}_error.log
    CustomLog ${APACHE_LOG_DIR}/{{ inventory_hostname }}.log combined

    LogLevel warn
    ServerSignature Off

    SetEnv SITE_CONFIG "{{ ooh_dir }}/site_config.py"

    WSGIProcessGroup {{ inventory_hostname }}
    WSGIApplicationGroup %{GLOBAL}
    WSGIDaemonProcess {{ inventory_hostname }} user=www-data group=www-data \
        processes=2 threads=4 python-home={{ ooh_venv_dir }} \
        home={{ ooh_dir }} locale=en_GB.UTF-8 queue-timeout=15 \
        socket-timeout=15 connect-timeout=15 request-timeout=15 \
        deadlock-timeout=15 graceful-timeout=5
    WSGIScriptAlias / {{ ooh_venv_dir }}/bin/ooh.wsgi

    AllowEncodedSlashes NoDecode

    AAHeaderKey none
    AAHeaders all
    AACacheControl off

    <Location />
        AuthType Ucam-WebAuth
        <RequireAny>
            Require valid-user
            Require ip {{ kiosk_ips }}
        </RequireAny>
    </Location>
</VirtualHost>
{% endif %}
